  var landscape = false;
  var countries = null;
  var hash = null;
  
  function mapSetup() {
    updateMap("");
    loadCountries();
    loadCapitals();
    selectRandom();
  }
  
  function updateMap(country) {
    var area = "usa";
    var chart = "http://chart.apis.google.com/chart?" 
                + "chs=" + (landscape ? "300x150" : "440x208")
                + "&chd=s:_&cht=t"
                + "&chtm=" + area 
                + "&chco=ffffff,ff0000,ff0000"
                + "&chld=" + country
                + "&chd=s:Af9"
                + "&chf=bg,s,404040"
    $("MapImage").src = chart;            
  }
  
  function countrySelected() {
    var value = $("CountrySelect").value;
    var country = hash[value];
    updateMap(value);
    if (country) {
      $("MapTitle").innerHTML = country.title;
      $("CapitalText").innerHTML = country.capital;
    }    
  } 
  
  function selectRandom() {
    var index = Math.floor(Math.random() * countries.length);
    $("CountrySelect").selectedIndex = index;
    countrySelected();
  }
  
  function fillCountrySelect() {
    $("CountrySelect").innerHTML = "";
    for (var i = 0; i < countries.length; i++) {
    	var option = document.createElement("option");
    	option.value = countries[i].code;
    	option.innerHTML = countries[i].title;
    	$("CountrySelect").appendChild(option);
    }    
  }
  
  function loadCountries() {
    var request = new XMLHttpRequest();
    request.open("GET", "states.txt", false);
    request.send(null);
    if (request.status == 200 || request.status == 0) {
      var lines = request.responseText.split("\n");
      countries = new Array(lines.length);
      hash = new Object();
      for (var i = 0; i < lines.length; i++) {
      	var line = lines[i];
      	var code = line.substring(0, 2);
      	var title = line.substring(3, line.length - 1);
     	  var country = new Object();
      	country.title = title;
      	country.code = code;
      	country.area = "u";
      	countries[i] = country;
      	hash[country.code] = country;
      }
    }
    for (var i = 0; i < countries.length; i++) {
    	var option = document.createElement("option");
    	option.value = countries[i].code;
    	option.innerHTML = countries[i].title;
    	$("CountrySelect").appendChild(option);
    }
  }
  
  function loadCapitals() {
    var request = new XMLHttpRequest();
    request.open("GET", "capitals.txt", false);
    request.send(null);
    if (request.status == 200 || request.status == 0) {
      var lines = request.responseText.split("\n");
      for (var i = 0; i < lines.length; i++) {
      	var tokens = lines[i].split("\t");
      	var code = tokens[1].substring(0, 2);
      	var country = hash[code];
      	country.capital = tokens[0];
      }
    }
  }
  
  function openWikipedia() {
    var value = $("CountrySelect").value;
    var country = hash[value];
    var url = "http://en.wikipedia.org/wiki/Special:Search?go=Go&search="
              + encodeURIComponent(country.title);
    widget.openURL(url);                 
  }
  
  function mapSelected() {
    
  }
  
  function $(id) {
    return document.getElementById(id);
  } 
  
  function debug(msg) {
    var e = document.getElementById("Debug");
    e.innerHTML += msg + "<br>";
  }
